(defun vlax-curve-getangleatpoint (en pt)
  (rem
    (angle '(0 0 0)
	   (vlax-curve-getFirstDeriv
	     en
	     (vlax-curve-getParamAtPoint en pt)
	   )
    )
    pi
  )
)
(defun gotonexten (en pt *ang* / box en2 en2lst ep i sp ss enang)
  (setq	box (* (/ (getvar "pickbox") (cadr (getvar "screensize")))
	       (getvar "viewsize")
	    )
  )
  (setq	ss (ssget "C"
		  (mapcar '- pt (list box box))
		  (mapcar '+ pt (list box box))
	   )
  )
  (if ss
    (progn
      (ssdel en ss)
      (setq i 0)
      (setq enang (vlax-curve-getangleatpoint en pt))
      (while (setq en2 (ssname ss i))
	(setq i (1+ i))
	(setq
	  sp (vl-catch-all-apply 'vlax-curve-getStartPoint (list en2))
	)
	(if (listp sp)
	  (progn
	    (setq ep (vlax-curve-getendPoint en2))
	    (cond
	      ((and
		 (equal sp pt 1e-8)
		 (equal enang (vlax-curve-getangleatpoint en2 sp) *ang*)
	       )
	       (setq en2lst (cons (list en2 ep) en2lst))
	      )
	      ((and
		 (equal ep pt 1e-8)
		 (equal enang (vlax-curve-getangleatpoint en2 ep) *ang*)
	       )
	       (setq en2lst (cons (list en2 sp) en2lst))
	      )
	    )
	  )
	)
      )
      en2lst
    )
  )
)
(defun ssgetnext (*ang* / en enp ept newss spt getnext)
  (setq enp (entsel2 "\nѡȡ:" '((0 . "*line,arc,ellipse"))))
  (setq en (car enp))
  (setq spt (vlax-curve-getStartPoint en))
  (setq ept (vlax-curve-getendPoint en))
  (setq newss (ssadd))
  (ssadd en newss)
  (defun addnext (en pt / next)
    (if	(setq next (gotonexten en pt *ang*))
      (foreach a next
	(if (not (ssmemb (car a) newss))
	  (progn
	    (ssadd (car a) newss)
	    (apply 'addnext a)
	  )
	)
      )
    )
  )
  (addnext en spt)
  (addnext en ept)
  (if (= 0 (getvar "cmdactive"))
    (sssetfirst nil newss)
  )
  newss
)